<html>
<head>
<title>OgreVector3.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreVector3.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreVector3_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Vector3_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Vector3_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreMath_8h.html">OgreMath.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreQuaternion_8h.html">OgreQuaternion.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00051"></a><a class="code" href="classOgre_1_1Vector3.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">public</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">00054</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, y, <a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056     <span class="keyword">public</span>:
<a name="l00057"></a><a class="code" href="classOgre_1_1Vector3.html#ab75a79e6126d060995368fe8647418eb">00057</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>()
<a name="l00058"></a>00058         {
<a name="l00059"></a>00059         }
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classOgre_1_1Vector3.html#a64c48c8b902431103b9e9d7a372cedd7">00061</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fX, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fY, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fZ )
<a name="l00062"></a>00062             : x( fX ), y( fY ), z( fZ )
<a name="l00063"></a>00063         {
<a name="l00064"></a>00064         }
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classOgre_1_1Vector3.html#afaa92dd5ee9762c5461cb6d7916f6d55">00066</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afCoordinate[3] )
<a name="l00067"></a>00067             : x( afCoordinate[0] ),
<a name="l00068"></a>00068               y( afCoordinate[1] ),
<a name="l00069"></a>00069               z( afCoordinate[2] )
<a name="l00070"></a>00070         {
<a name="l00071"></a>00071         }
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classOgre_1_1Vector3.html#ac3c34be918e6bea663404c5364dad048">00073</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <span class="keyword">const</span> <span class="keywordtype">int</span> afCoordinate[3] )
<a name="l00074"></a>00074         {
<a name="l00075"></a>00075             x = (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[0];
<a name="l00076"></a>00076             y = (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[1];
<a name="l00077"></a>00077             z = (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[2];
<a name="l00078"></a>00078         }
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classOgre_1_1Vector3.html#a6c55bec7491f10ea8c661d82daa602b0">00080</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* <span class="keyword">const</span> r )
<a name="l00081"></a>00081             : x( r[0] ), y( r[1] ), z( r[2] )
<a name="l00082"></a>00082         {
<a name="l00083"></a>00083         }
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classOgre_1_1Vector3.html#a84db6b6e0412f7a2e91e50649d6d9794">00085</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scaler )
<a name="l00086"></a>00086             : x( scaler )
<a name="l00087"></a>00087             , y( scaler )
<a name="l00088"></a>00088             , z( scaler )
<a name="l00089"></a>00089         {
<a name="l00090"></a>00090         }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00095"></a><a class="code" href="classOgre_1_1Vector3.html#a2de7638f0d38e460e1b65c8953f0c45f">00095</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">swap</a>(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; other)
<a name="l00096"></a>00096         {
<a name="l00097"></a>00097             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(x, other.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>);
<a name="l00098"></a>00098             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(y, other.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>);
<a name="l00099"></a>00099             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(z, other.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00100"></a>00100         }
<a name="l00101"></a>00101 
<a name="l00102"></a><a class="code" href="classOgre_1_1Vector3.html#a776848af1b3d4d74b9e54ec8de046b36">00102</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )<span class="keyword"> const</span>
<a name="l00103"></a>00103 <span class="keyword">        </span>{
<a name="l00104"></a>00104             assert( i &lt; 3 );
<a name="l00105"></a>00105 
<a name="l00106"></a>00106             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00107"></a>00107         }
<a name="l00108"></a>00108 
<a name="l00109"></a><a class="code" href="classOgre_1_1Vector3.html#ab5a34a541047cf3b7aa223d77ee8f126">00109</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )
<a name="l00110"></a>00110         {
<a name="l00111"></a>00111             assert( i &lt; 3 );
<a name="l00112"></a>00112 
<a name="l00113"></a>00113             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00114"></a>00114         }
<a name="l00116"></a><a class="code" href="classOgre_1_1Vector3.html#a7952f09744c63b5230ba4ea4b2c2d00a">00116</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()
<a name="l00117"></a>00117         {
<a name="l00118"></a>00118             <span class="keywordflow">return</span> &amp;x;
<a name="l00119"></a>00119         }
<a name="l00121"></a><a class="code" href="classOgre_1_1Vector3.html#a4fc4943ff293f3b78f7e0f6602e67657">00121</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()<span class="keyword"> const</span>
<a name="l00122"></a>00122 <span class="keyword">        </span>{
<a name="l00123"></a>00123             <span class="keywordflow">return</span> &amp;x;
<a name="l00124"></a>00124         }
<a name="l00125"></a>00125 
<a name="l00130"></a><a class="code" href="classOgre_1_1Vector3.html#ab5de4a9f833c4427a3b2105fcd6f96ad">00130</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00131"></a>00131         {
<a name="l00132"></a>00132             x = rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00133"></a>00133             y = rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00134"></a>00134             z = rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00137"></a>00137         }
<a name="l00138"></a>00138 
<a name="l00139"></a><a class="code" href="classOgre_1_1Vector3.html#a554fbfe97d222e9e7669faf168104f06">00139</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScaler )
<a name="l00140"></a>00140         {
<a name="l00141"></a>00141             x = fScaler;
<a name="l00142"></a>00142             y = fScaler;
<a name="l00143"></a>00143             z = fScaler;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00146"></a>00146         }
<a name="l00147"></a>00147 
<a name="l00148"></a><a class="code" href="classOgre_1_1Vector3.html#a4911c81b5674a51a267f672d94519bd7">00148</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator == </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00149"></a>00149 <span class="keyword">        </span>{
<a name="l00150"></a>00150             <span class="keywordflow">return</span> ( x == rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &amp;&amp; y == rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &amp;&amp; z == rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> );
<a name="l00151"></a>00151         }
<a name="l00152"></a>00152 
<a name="l00153"></a><a class="code" href="classOgre_1_1Vector3.html#a6912f6690162a822f5606daef1345588">00153</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator != </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00154"></a>00154 <span class="keyword">        </span>{
<a name="l00155"></a>00155             <span class="keywordflow">return</span> ( x != rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> || y != rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> || z != rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> );
<a name="l00156"></a>00156         }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158         <span class="comment">// arithmetic operations</span>
<a name="l00159"></a><a class="code" href="classOgre_1_1Vector3.html#af382b37682a172c036d1141083aeb351">00159</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator + ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00160"></a>00160 <span class="keyword">        </span>{
<a name="l00161"></a>00161             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00162"></a>00162                 x + rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00163"></a>00163                 y + rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00164"></a>00164                 z + rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00165"></a>00165         }
<a name="l00166"></a>00166 
<a name="l00167"></a><a class="code" href="classOgre_1_1Vector3.html#ab9a92534cc5b9799ea749ff9fb4f63af">00167</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator - ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00168"></a>00168 <span class="keyword">        </span>{
<a name="l00169"></a>00169             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00170"></a>00170                 x - rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00171"></a>00171                 y - rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00172"></a>00172                 z - rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00173"></a>00173         }
<a name="l00174"></a>00174 
<a name="l00175"></a><a class="code" href="classOgre_1_1Vector3.html#a288bbe9c7eb3dbcbd98bebf13a7102d3">00175</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00176"></a>00176 <span class="keyword">        </span>{
<a name="l00177"></a>00177             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00178"></a>00178                 x * fScalar,
<a name="l00179"></a>00179                 y * fScalar,
<a name="l00180"></a>00180                 z * fScalar);
<a name="l00181"></a>00181         }
<a name="l00182"></a>00182 
<a name="l00183"></a><a class="code" href="classOgre_1_1Vector3.html#ac140a4cf536963a70776cb5baba06195">00183</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00184"></a>00184 <span class="keyword">        </span>{
<a name="l00185"></a>00185             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00186"></a>00186                 x * rhs.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00187"></a>00187                 y * rhs.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00188"></a>00188                 z * rhs.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00189"></a>00189         }
<a name="l00190"></a>00190 
<a name="l00191"></a><a class="code" href="classOgre_1_1Vector3.html#ac3c3bfa100cfa73e20523b8ab569626d">00191</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00192"></a>00192 <span class="keyword">        </span>{
<a name="l00193"></a>00193             assert( fScalar != 0.0 );
<a name="l00194"></a>00194 
<a name="l00195"></a>00195             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0f / fScalar;
<a name="l00196"></a>00196 
<a name="l00197"></a>00197             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00198"></a>00198                 x * fInv,
<a name="l00199"></a>00199                 y * fInv,
<a name="l00200"></a>00200                 z * fInv);
<a name="l00201"></a>00201         }
<a name="l00202"></a>00202 
<a name="l00203"></a><a class="code" href="classOgre_1_1Vector3.html#a1a3b1399fe72dd39eba3ca78c5efe491">00203</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00204"></a>00204 <span class="keyword">        </span>{
<a name="l00205"></a>00205             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00206"></a>00206                 x / rhs.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00207"></a>00207                 y / rhs.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00208"></a>00208                 z / rhs.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00209"></a>00209         }
<a name="l00210"></a>00210 
<a name="l00211"></a><a class="code" href="classOgre_1_1Vector3.html#ad6f60ae56629526dc89c1f725297d403">00211</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator + ()<span class="keyword"> const</span>
<a name="l00212"></a>00212 <span class="keyword">        </span>{
<a name="l00213"></a>00213             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00214"></a>00214         }
<a name="l00215"></a>00215 
<a name="l00216"></a><a class="code" href="classOgre_1_1Vector3.html#a73971f7dd2342f5077509d23d277930b">00216</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator - ()<span class="keyword"> const</span>
<a name="l00217"></a>00217 <span class="keyword">        </span>{
<a name="l00218"></a>00218             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(-x, -y, -z);
<a name="l00219"></a>00219         }
<a name="l00220"></a>00220 
<a name="l00221"></a>00221         <span class="comment">// overloaded operators to help Vector3</span>
<a name="l00222"></a><a class="code" href="classOgre_1_1Vector3.html#a92d7a0e4025b82401c2baa1e43c86ab1">00222</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00223"></a>00223         {
<a name="l00224"></a>00224             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00225"></a>00225                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00226"></a>00226                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00227"></a>00227                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00228"></a>00228         }
<a name="l00229"></a>00229 
<a name="l00230"></a><a class="code" href="classOgre_1_1Vector3.html#a3505ef8e8c296ad49bdbe837185fa0e2">00230</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00231"></a>00231         {
<a name="l00232"></a>00232             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00233"></a>00233                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00234"></a>00234                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00235"></a>00235                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00236"></a>00236         }
<a name="l00237"></a>00237 
<a name="l00238"></a><a class="code" href="classOgre_1_1Vector3.html#a09fc339aca944e8b0bb21d02215a092e">00238</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator + (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00239"></a>00239         {
<a name="l00240"></a>00240             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00241"></a>00241                 lhs.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> + rhs,
<a name="l00242"></a>00242                 lhs.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> + rhs,
<a name="l00243"></a>00243                 lhs.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> + rhs);
<a name="l00244"></a>00244         }
<a name="l00245"></a>00245 
<a name="l00246"></a><a class="code" href="classOgre_1_1Vector3.html#aa5a711e980d3f906f83bf4740b573aaf">00246</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator + (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)
<a name="l00247"></a>00247         {
<a name="l00248"></a>00248             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00249"></a>00249                 lhs + rhs.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00250"></a>00250                 lhs + rhs.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00251"></a>00251                 lhs + rhs.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00252"></a>00252         }
<a name="l00253"></a>00253 
<a name="l00254"></a><a class="code" href="classOgre_1_1Vector3.html#a2c6a217a917e372153a225a53fd5b99f">00254</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator - (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00255"></a>00255         {
<a name="l00256"></a>00256             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00257"></a>00257                 lhs.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> - rhs,
<a name="l00258"></a>00258                 lhs.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> - rhs,
<a name="l00259"></a>00259                 lhs.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> - rhs);
<a name="l00260"></a>00260         }
<a name="l00261"></a>00261 
<a name="l00262"></a><a class="code" href="classOgre_1_1Vector3.html#aeca31428e2157b9a26380b3a7eec482e">00262</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> operator - (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)
<a name="l00263"></a>00263         {
<a name="l00264"></a>00264             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00265"></a>00265                 lhs - rhs.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>,
<a name="l00266"></a>00266                 lhs - rhs.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00267"></a>00267                 lhs - rhs.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00268"></a>00268         }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270         <span class="comment">// arithmetic updates</span>
<a name="l00271"></a><a class="code" href="classOgre_1_1Vector3.html#ae3ac60e2c77755046f6a00f09f54793a">00271</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00272"></a>00272         {
<a name="l00273"></a>00273             x += rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00274"></a>00274             y += rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00275"></a>00275             z += rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00276"></a>00276 
<a name="l00277"></a>00277             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00278"></a>00278         }
<a name="l00279"></a>00279 
<a name="l00280"></a><a class="code" href="classOgre_1_1Vector3.html#a1ee74f38b762d0d0a5bf961268a74a74">00280</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00281"></a>00281         {
<a name="l00282"></a>00282             x += fScalar;
<a name="l00283"></a>00283             y += fScalar;
<a name="l00284"></a>00284             z += fScalar;
<a name="l00285"></a>00285             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00286"></a>00286         }
<a name="l00287"></a>00287 
<a name="l00288"></a><a class="code" href="classOgre_1_1Vector3.html#ac514b9e1f5dbe855b1458a2d72a27621">00288</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00289"></a>00289         {
<a name="l00290"></a>00290             x -= rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00291"></a>00291             y -= rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00292"></a>00292             z -= rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00293"></a>00293 
<a name="l00294"></a>00294             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00295"></a>00295         }
<a name="l00296"></a>00296 
<a name="l00297"></a><a class="code" href="classOgre_1_1Vector3.html#adb8b9ff11371c1b011f8d46c36c54d40">00297</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00298"></a>00298         {
<a name="l00299"></a>00299             x -= fScalar;
<a name="l00300"></a>00300             y -= fScalar;
<a name="l00301"></a>00301             z -= fScalar;
<a name="l00302"></a>00302             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00303"></a>00303         }
<a name="l00304"></a>00304 
<a name="l00305"></a><a class="code" href="classOgre_1_1Vector3.html#a78fde8c253396d0f2d5c9c3513a7a45e">00305</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00306"></a>00306         {
<a name="l00307"></a>00307             x *= fScalar;
<a name="l00308"></a>00308             y *= fScalar;
<a name="l00309"></a>00309             z *= fScalar;
<a name="l00310"></a>00310             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00311"></a>00311         }
<a name="l00312"></a>00312 
<a name="l00313"></a><a class="code" href="classOgre_1_1Vector3.html#ae07f7542f2e4929d92c0a2beb85b4ed8">00313</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00314"></a>00314         {
<a name="l00315"></a>00315             x *= rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00316"></a>00316             y *= rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00317"></a>00317             z *= rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00320"></a>00320         }
<a name="l00321"></a>00321 
<a name="l00322"></a><a class="code" href="classOgre_1_1Vector3.html#afd733cc4140ba78de2427b8fa9951e12">00322</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00323"></a>00323         {
<a name="l00324"></a>00324             assert( fScalar != 0.0 );
<a name="l00325"></a>00325 
<a name="l00326"></a>00326             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0f / fScalar;
<a name="l00327"></a>00327 
<a name="l00328"></a>00328             x *= fInv;
<a name="l00329"></a>00329             y *= fInv;
<a name="l00330"></a>00330             z *= fInv;
<a name="l00331"></a>00331 
<a name="l00332"></a>00332             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00333"></a>00333         }
<a name="l00334"></a>00334 
<a name="l00335"></a><a class="code" href="classOgre_1_1Vector3.html#ad8b5fad0c40ae5dd087bbade10b8403e">00335</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )
<a name="l00336"></a>00336         {
<a name="l00337"></a>00337             x /= rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00338"></a>00338             y /= rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00339"></a>00339             z /= rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00340"></a>00340 
<a name="l00341"></a>00341             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00342"></a>00342         }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00352"></a><a class="code" href="classOgre_1_1Vector3.html#aaf4b62c1fe4d51e3a49b76490900d843">00352</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length ()<span class="keyword"> const</span>
<a name="l00353"></a>00353 <span class="keyword">        </span>{
<a name="l00354"></a>00354             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#ab1ee8b71699ce68bd8cf91113ead793e" title="Square root function.">Math::Sqrt</a>( x * x + y * y + z * z );
<a name="l00355"></a>00355         }
<a name="l00356"></a>00356 
<a name="l00367"></a><a class="code" href="classOgre_1_1Vector3.html#ad465ee0d92aaa5e760b835b8f0db711d">00367</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> squaredLength ()<span class="keyword"> const</span>
<a name="l00368"></a>00368 <span class="keyword">        </span>{
<a name="l00369"></a>00369             <span class="keywordflow">return</span> x * x + y * y + z * z;
<a name="l00370"></a>00370         }
<a name="l00371"></a>00371 
<a name="l00379"></a><a class="code" href="classOgre_1_1Vector3.html#a146a420f1319626829627482b83ead38">00379</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> distance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00380"></a>00380 <span class="keyword">        </span>{
<a name="l00381"></a>00381             <span class="keywordflow">return</span> (*<span class="keyword">this</span> - rhs).length();
<a name="l00382"></a>00382         }
<a name="l00383"></a>00383 
<a name="l00394"></a><a class="code" href="classOgre_1_1Vector3.html#a4417057512532ff59fc2c980a3c8a599">00394</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> squaredDistance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00395"></a>00395 <span class="keyword">        </span>{
<a name="l00396"></a>00396             <span class="keywordflow">return</span> (*<span class="keyword">this</span> - rhs).squaredLength();
<a name="l00397"></a>00397         }
<a name="l00398"></a>00398 
<a name="l00413"></a><a class="code" href="classOgre_1_1Vector3.html#aa4063f05819fcb3d1bef754718608976">00413</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dotProduct(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00414"></a>00414 <span class="keyword">        </span>{
<a name="l00415"></a>00415             <span class="keywordflow">return</span> x * vec.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> + y * vec.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> + z * vec.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00416"></a>00416         }
<a name="l00417"></a>00417 
<a name="l00428"></a><a class="code" href="classOgre_1_1Vector3.html#a8572c00ede9c7d6db9e4f885b3d4476e">00428</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> absDotProduct(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00429"></a>00429 <span class="keyword">        </span>{
<a name="l00430"></a>00430             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(x * vec.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>) + <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(y * vec.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>) + <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(z * vec.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>);
<a name="l00431"></a>00431         }
<a name="l00432"></a>00432 
<a name="l00442"></a><a class="code" href="classOgre_1_1Vector3.html#a9e572a5cc4e1ed826839e5281d8f1d3b">00442</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> normalise()
<a name="l00443"></a>00443         {
<a name="l00444"></a>00444             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fLength = <a class="code" href="classOgre_1_1Math.html#ab1ee8b71699ce68bd8cf91113ead793e" title="Square root function.">Math::Sqrt</a>( x * x + y * y + z * z );
<a name="l00445"></a>00445 
<a name="l00446"></a>00446             <span class="comment">// Will also work for zero-sized vectors, but will change nothing</span>
<a name="l00447"></a>00447             <span class="comment">// We&#39;re not using epsilons because we don&#39;t need to.</span>
<a name="l00448"></a>00448             <span class="comment">// Read http://www.ogre3d.org/forums/viewtopic.php?f=4&amp;t=61259</span>
<a name="l00449"></a>00449             <span class="keywordflow">if</span> ( fLength &gt; <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>(0.0f) )
<a name="l00450"></a>00450             {
<a name="l00451"></a>00451                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInvLength = 1.0f / fLength;
<a name="l00452"></a>00452                 x *= fInvLength;
<a name="l00453"></a>00453                 y *= fInvLength;
<a name="l00454"></a>00454                 z *= fInvLength;
<a name="l00455"></a>00455             }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457             <span class="keywordflow">return</span> fLength;
<a name="l00458"></a>00458         }
<a name="l00459"></a>00459 
<a name="l00488"></a><a class="code" href="classOgre_1_1Vector3.html#a22832c010c733fcdd4f3ac7daa99a006">00488</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> crossProduct( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00489"></a>00489 <span class="keyword">        </span>{
<a name="l00490"></a>00490             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00491"></a>00491                 y * rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> - z * rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>,
<a name="l00492"></a>00492                 z * rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> - x * rkVector.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>,
<a name="l00493"></a>00493                 x * rkVector.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> - y * rkVector.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>);
<a name="l00494"></a>00494         }
<a name="l00495"></a>00495 
<a name="l00499"></a><a class="code" href="classOgre_1_1Vector3.html#a3c770ca212fb3b84f6668c96a2b67ae2">00499</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> midPoint( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec )<span class="keyword"> const</span>
<a name="l00500"></a>00500 <span class="keyword">        </span>{
<a name="l00501"></a>00501             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(
<a name="l00502"></a>00502                 ( x + vec.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> ) * 0.5f,
<a name="l00503"></a>00503                 ( y + vec.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> ) * 0.5f,
<a name="l00504"></a>00504                 ( z + vec.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> ) * 0.5f );
<a name="l00505"></a>00505         }
<a name="l00506"></a>00506 
<a name="l00510"></a><a class="code" href="classOgre_1_1Vector3.html#af84d6701735b0c5f0a0f1534ef5ed46c">00510</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__General.html#gae1dbf4506ab2500da5ec4ef0b58cb2e1">operator &lt; </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs )<span class="keyword"> const</span>
<a name="l00511"></a>00511 <span class="keyword">        </span>{
<a name="l00512"></a>00512             <span class="keywordflow">if</span>( x &lt; rhs.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &amp;&amp; y &lt; rhs.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &amp;&amp; z &lt; rhs.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> )
<a name="l00513"></a>00513                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00514"></a>00514             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00515"></a>00515         }
<a name="l00516"></a>00516 
<a name="l00520"></a><a class="code" href="classOgre_1_1Vector3.html#a17134a53241f0ccdecc851616f2c6464">00520</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator &gt; ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs )<span class="keyword"> const</span>
<a name="l00521"></a>00521 <span class="keyword">        </span>{
<a name="l00522"></a>00522             <span class="keywordflow">if</span>( x &gt; rhs.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &amp;&amp; y &gt; rhs.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &amp;&amp; z &gt; rhs.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> )
<a name="l00523"></a>00523                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00524"></a>00524             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00525"></a>00525         }
<a name="l00526"></a>00526 
<a name="l00534"></a><a class="code" href="classOgre_1_1Vector3.html#a8430bb9f7756acb8256497f004afac49">00534</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> makeFloor( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; cmp )
<a name="l00535"></a>00535         {
<a name="l00536"></a>00536             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &lt; x ) x = cmp.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00537"></a>00537             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &lt; y ) y = cmp.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00538"></a>00538             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &lt; z ) z = cmp.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00539"></a>00539         }
<a name="l00540"></a>00540 
<a name="l00548"></a><a class="code" href="classOgre_1_1Vector3.html#a61e91dcf16f7db52d299e976526218e3">00548</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> makeCeil( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; cmp )
<a name="l00549"></a>00549         {
<a name="l00550"></a>00550             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &gt; x ) x = cmp.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>;
<a name="l00551"></a>00551             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &gt; y ) y = cmp.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>;
<a name="l00552"></a>00552             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &gt; z ) z = cmp.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00553"></a>00553         }
<a name="l00554"></a>00554 
<a name="l00562"></a><a class="code" href="classOgre_1_1Vector3.html#af654ef1e00ba82ca63695336b81da153">00562</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> perpendicular(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00563"></a>00563 <span class="keyword">        </span>{
<a name="l00564"></a>00564             <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fSquareZero = (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)(1e-06 * 1e-06);
<a name="l00565"></a>00565 
<a name="l00566"></a>00566             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> perp = this-&gt;crossProduct( <a class="code" href="classOgre_1_1Vector3.html#a0c21d1f120c5eab83aa966e5de1df311">Vector3::UNIT_X</a> );
<a name="l00567"></a>00567 
<a name="l00568"></a>00568             <span class="comment">// Check length</span>
<a name="l00569"></a>00569             <span class="keywordflow">if</span>( perp.<a class="code" href="classOgre_1_1Vector3.html#ad465ee0d92aaa5e760b835b8f0db711d" title="Returns the square of the length(magnitude) of the vector.">squaredLength</a>() &lt; fSquareZero )
<a name="l00570"></a>00570             {
<a name="l00571"></a>00571                 <span class="comment">/* This vector is the Y axis multiplied by a scalar, so we have</span>
<a name="l00572"></a>00572 <span class="comment">                   to use another axis.</span>
<a name="l00573"></a>00573 <span class="comment">                */</span>
<a name="l00574"></a>00574                 perp = this-&gt;crossProduct( <a class="code" href="classOgre_1_1Vector3.html#a8d1a1f7af535bcc8d9c78b1732bc1b90">Vector3::UNIT_Y</a> );
<a name="l00575"></a>00575             }
<a name="l00576"></a>00576             perp.<a class="code" href="classOgre_1_1Vector3.html#a9e572a5cc4e1ed826839e5281d8f1d3b" title="Normalises the vector.">normalise</a>();
<a name="l00577"></a>00577 
<a name="l00578"></a>00578             <span class="keywordflow">return</span> perp;
<a name="l00579"></a>00579         }
<a name="l00599"></a><a class="code" href="classOgre_1_1Vector3.html#a371428dc4de1c24544746973637fc7a9">00599</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> randomDeviant(
<a name="l00600"></a>00600             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle,
<a name="l00601"></a>00601             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; up = <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a> )<span class="keyword"> const</span>
<a name="l00602"></a>00602 <span class="keyword">        </span>{
<a name="l00603"></a>00603             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> newUp;
<a name="l00604"></a>00604 
<a name="l00605"></a>00605             <span class="keywordflow">if</span> (up == <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>)
<a name="l00606"></a>00606             {
<a name="l00607"></a>00607                 <span class="comment">// Generate an up vector</span>
<a name="l00608"></a>00608                 newUp = this-&gt;perpendicular();
<a name="l00609"></a>00609             }
<a name="l00610"></a>00610             <span class="keywordflow">else</span>
<a name="l00611"></a>00611             {
<a name="l00612"></a>00612                 newUp = up;
<a name="l00613"></a>00613             }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615             <span class="comment">// Rotate up vector by random amount around this</span>
<a name="l00616"></a>00616             <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> q;
<a name="l00617"></a>00617             q.<a class="code" href="classOgre_1_1Quaternion.html#ac3328c1bb86d17e870c57d52720e2e32" title="Setups the quaternion using the supplied vector, and &quot;roll&quot; around that vector by the specified radia...">FromAngleAxis</a>( <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>(<a class="code" href="classOgre_1_1Math.html#a17da3bb870f8654628d6f429a144aea1" title="Generate a random number of unit length.">Math::UnitRandom</a>() * <a class="code" href="classOgre_1_1Math.html#a58d139439316e19e9142000f1a6bdf6d">Math::TWO_PI</a>), *<span class="keyword">this</span> );
<a name="l00618"></a>00618             newUp = q * newUp;
<a name="l00619"></a>00619 
<a name="l00620"></a>00620             <span class="comment">// Finally rotate this by given angle around randomised up</span>
<a name="l00621"></a>00621             q.<a class="code" href="classOgre_1_1Quaternion.html#ac3328c1bb86d17e870c57d52720e2e32" title="Setups the quaternion using the supplied vector, and &quot;roll&quot; around that vector by the specified radia...">FromAngleAxis</a>( angle, newUp );
<a name="l00622"></a>00622             <span class="keywordflow">return</span> q * (*this);
<a name="l00623"></a>00623         }
<a name="l00624"></a>00624 
<a name="l00629"></a><a class="code" href="classOgre_1_1Vector3.html#a2c575b9fbc5d2cb40027d3768a731c1f">00629</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> angleBetween(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00630"></a>00630 <span class="keyword">        </span>{
<a name="l00631"></a>00631             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lenProduct = length() * dest.<a class="code" href="classOgre_1_1Vector3.html#aaf4b62c1fe4d51e3a49b76490900d843" title="Returns the length (magnitude) of the vector.">length</a>();
<a name="l00632"></a>00632 
<a name="l00633"></a>00633             <span class="comment">// Divide by zero check</span>
<a name="l00634"></a>00634             <span class="keywordflow">if</span>(lenProduct &lt; 1e-6f)
<a name="l00635"></a>00635                 lenProduct = 1e-6f;
<a name="l00636"></a>00636 
<a name="l00637"></a>00637             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> f = dotProduct(dest) / lenProduct;
<a name="l00638"></a>00638 
<a name="l00639"></a>00639             f = <a class="code" href="classOgre_1_1Math.html#a0de224c93b57ff8414892d77f9a2d81d" title="Clamp a value within an inclusive range.">Math::Clamp</a>(f, (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)-1.0, (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)1.0);
<a name="l00640"></a>00640             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a53869f3197b0f991aea7f5edf6b620e2" title="Arc cosine function.">Math::ACos</a>(f);
<a name="l00641"></a>00641 
<a name="l00642"></a>00642         }
<a name="l00651"></a><a class="code" href="classOgre_1_1Vector3.html#aeeef4472ad0c4d5f34a038a9f2faa819">00651</a>         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> getRotationTo(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; dest,
<a name="l00652"></a>00652             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; fallbackAxis = <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>)<span class="keyword"> const</span>
<a name="l00653"></a>00653 <span class="keyword">        </span>{
<a name="l00654"></a>00654             <span class="comment">// Based on Stan Melax&#39;s article in Game Programming Gems</span>
<a name="l00655"></a>00655             <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> q;
<a name="l00656"></a>00656             <span class="comment">// Copy, since cannot modify local</span>
<a name="l00657"></a>00657             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> v0 = *<span class="keyword">this</span>;
<a name="l00658"></a>00658             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> v1 = dest;
<a name="l00659"></a>00659             v0.<a class="code" href="classOgre_1_1Vector3.html#a9e572a5cc4e1ed826839e5281d8f1d3b" title="Normalises the vector.">normalise</a>();
<a name="l00660"></a>00660             v1.<a class="code" href="classOgre_1_1Vector3.html#a9e572a5cc4e1ed826839e5281d8f1d3b" title="Normalises the vector.">normalise</a>();
<a name="l00661"></a>00661 
<a name="l00662"></a>00662             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> d = v0.<a class="code" href="classOgre_1_1Vector3.html#aa4063f05819fcb3d1bef754718608976" title="Calculates the dot (scalar) product of this vector with another.">dotProduct</a>(v1);
<a name="l00663"></a>00663             <span class="comment">// If dot == 1, vectors are the same</span>
<a name="l00664"></a>00664             <span class="keywordflow">if</span> (d &gt;= 1.0f)
<a name="l00665"></a>00665             {
<a name="l00666"></a>00666                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a>;
<a name="l00667"></a>00667             }
<a name="l00668"></a>00668             <span class="keywordflow">if</span> (d &lt; (1e-6f - 1.0f))
<a name="l00669"></a>00669             {
<a name="l00670"></a>00670                 <span class="keywordflow">if</span> (fallbackAxis != <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>)
<a name="l00671"></a>00671                 {
<a name="l00672"></a>00672                     <span class="comment">// rotate 180 degrees about the fallback axis</span>
<a name="l00673"></a>00673                     q.<a class="code" href="classOgre_1_1Quaternion.html#ac3328c1bb86d17e870c57d52720e2e32" title="Setups the quaternion using the supplied vector, and &quot;roll&quot; around that vector by the specified radia...">FromAngleAxis</a>(<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>(<a class="code" href="classOgre_1_1Math.html#aee3e908f569f6d83d8359ef0d88a0461">Math::PI</a>), fallbackAxis);
<a name="l00674"></a>00674                 }
<a name="l00675"></a>00675                 <span class="keywordflow">else</span>
<a name="l00676"></a>00676                 {
<a name="l00677"></a>00677                     <span class="comment">// Generate an axis</span>
<a name="l00678"></a>00678                     <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> axis = <a class="code" href="classOgre_1_1Vector3.html#a0c21d1f120c5eab83aa966e5de1df311">Vector3::UNIT_X</a>.<a class="code" href="classOgre_1_1Vector3.html#a22832c010c733fcdd4f3ac7daa99a006" title="Calculates the cross-product of 2 vectors, i.e.">crossProduct</a>(*<span class="keyword">this</span>);
<a name="l00679"></a>00679                     <span class="keywordflow">if</span> (axis.<a class="code" href="classOgre_1_1Vector3.html#a6fb95c613736dbf41a6b193547cc8fee" title="Returns true if this vector is zero length.">isZeroLength</a>()) <span class="comment">// pick another if colinear</span>
<a name="l00680"></a>00680                         axis = <a class="code" href="classOgre_1_1Vector3.html#a8d1a1f7af535bcc8d9c78b1732bc1b90">Vector3::UNIT_Y</a>.crossProduct(*<span class="keyword">this</span>);
<a name="l00681"></a>00681                     axis.<a class="code" href="classOgre_1_1Vector3.html#a9e572a5cc4e1ed826839e5281d8f1d3b" title="Normalises the vector.">normalise</a>();
<a name="l00682"></a>00682                     q.<a class="code" href="classOgre_1_1Quaternion.html#ac3328c1bb86d17e870c57d52720e2e32" title="Setups the quaternion using the supplied vector, and &quot;roll&quot; around that vector by the specified radia...">FromAngleAxis</a>(<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>(<a class="code" href="classOgre_1_1Math.html#aee3e908f569f6d83d8359ef0d88a0461">Math::PI</a>), axis);
<a name="l00683"></a>00683                 }
<a name="l00684"></a>00684             }
<a name="l00685"></a>00685             <span class="keywordflow">else</span>
<a name="l00686"></a>00686             {
<a name="l00687"></a>00687                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> s = <a class="code" href="classOgre_1_1Math.html#ab1ee8b71699ce68bd8cf91113ead793e" title="Square root function.">Math::Sqrt</a>( (1+d)*2 );
<a name="l00688"></a>00688                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> invs = 1 / s;
<a name="l00689"></a>00689 
<a name="l00690"></a>00690                 <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> c = v0.<a class="code" href="classOgre_1_1Vector3.html#a22832c010c733fcdd4f3ac7daa99a006" title="Calculates the cross-product of 2 vectors, i.e.">crossProduct</a>(v1);
<a name="l00691"></a>00691 
<a name="l00692"></a>00692                 q.<a class="code" href="classOgre_1_1Quaternion.html#a32c5680516b41bc4ba3159bf4d4abaf1">x</a> = c.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> * invs;
<a name="l00693"></a>00693                 q.<a class="code" href="classOgre_1_1Quaternion.html#aa7328cd3883a92ee9c9322805d038f11">y</a> = c.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> * invs;
<a name="l00694"></a>00694                 q.<a class="code" href="classOgre_1_1Quaternion.html#a31ec84a931236554c0c17e37bf5ace97">z</a> = c.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> * invs;
<a name="l00695"></a>00695                 q.<a class="code" href="classOgre_1_1Quaternion.html#af3424f1e07092c0ffe293d18b277a04f">w</a> = s * 0.5f;
<a name="l00696"></a>00696                 q.<a class="code" href="classOgre_1_1Quaternion.html#aee94ec9c7de50fe7f774ae4c7e760b65" title="Normalises this quaternion, and returns the previous length.">normalise</a>();
<a name="l00697"></a>00697             }
<a name="l00698"></a>00698             <span class="keywordflow">return</span> q;
<a name="l00699"></a>00699         }
<a name="l00700"></a>00700 
<a name="l00702"></a><a class="code" href="classOgre_1_1Vector3.html#a6fb95c613736dbf41a6b193547cc8fee">00702</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isZeroLength(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00703"></a>00703 <span class="keyword">        </span>{
<a name="l00704"></a>00704             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sqlen = (x * x) + (y * y) + (z * z);
<a name="l00705"></a>00705             <span class="keywordflow">return</span> (sqlen &lt; (1e-06 * 1e-06));
<a name="l00706"></a>00706 
<a name="l00707"></a>00707         }
<a name="l00708"></a>00708 
<a name="l00711"></a><a class="code" href="classOgre_1_1Vector3.html#a50bec7fc9389d530ed6caac9b74bae7b">00711</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> normalisedCopy(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00712"></a>00712 <span class="keyword">        </span>{
<a name="l00713"></a>00713             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> ret = *<span class="keyword">this</span>;
<a name="l00714"></a>00714             ret.<a class="code" href="classOgre_1_1Vector3.html#a9e572a5cc4e1ed826839e5281d8f1d3b" title="Normalises the vector.">normalise</a>();
<a name="l00715"></a>00715             <span class="keywordflow">return</span> ret;
<a name="l00716"></a>00716         }
<a name="l00717"></a>00717 
<a name="l00721"></a><a class="code" href="classOgre_1_1Vector3.html#a2bf94b1c0ac1fa59c16dc6e1bff39f9c">00721</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> reflect(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; normal)<span class="keyword"> const</span>
<a name="l00722"></a>00722 <span class="keyword">        </span>{
<a name="l00723"></a>00723             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>( *<span class="keyword">this</span> - ( 2 * this-&gt;dotProduct(normal) * normal ) );
<a name="l00724"></a>00724         }
<a name="l00725"></a>00725 
<a name="l00732"></a><a class="code" href="classOgre_1_1Vector3.html#a824cd193cc75dd39ccc74bad0cc7182d">00732</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> positionEquals(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> tolerance = 1e-03)<span class="keyword"> const</span>
<a name="l00733"></a>00733 <span class="keyword">        </span>{
<a name="l00734"></a>00734             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(x, rhs.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>, tolerance) &amp;&amp;
<a name="l00735"></a>00735                 <a class="code" href="classOgre_1_1Math.html#a890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(y, rhs.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>, tolerance) &amp;&amp;
<a name="l00736"></a>00736                 <a class="code" href="classOgre_1_1Math.html#a890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(z, rhs.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>, tolerance);
<a name="l00737"></a>00737 
<a name="l00738"></a>00738         }
<a name="l00739"></a>00739 
<a name="l00746"></a><a class="code" href="classOgre_1_1Vector3.html#ab0b7a22e68461036f00179ae909193f4">00746</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> positionCloses(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> tolerance = 1e-03f)<span class="keyword"> const</span>
<a name="l00747"></a>00747 <span class="keyword">        </span>{
<a name="l00748"></a>00748             <span class="keywordflow">return</span> squaredDistance(rhs) &lt;=
<a name="l00749"></a>00749                 (squaredLength() + rhs.<a class="code" href="classOgre_1_1Vector3.html#ad465ee0d92aaa5e760b835b8f0db711d" title="Returns the square of the length(magnitude) of the vector.">squaredLength</a>()) * tolerance;
<a name="l00750"></a>00750         }
<a name="l00751"></a>00751 
<a name="l00759"></a><a class="code" href="classOgre_1_1Vector3.html#a97208398c491c8b3f68de8e8c0c3b789">00759</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> directionEquals(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rhs,
<a name="l00760"></a>00760             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; tolerance)<span class="keyword"> const</span>
<a name="l00761"></a>00761 <span class="keyword">        </span>{
<a name="l00762"></a>00762             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dot = dotProduct(rhs);
<a name="l00763"></a>00763             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> angle = <a class="code" href="classOgre_1_1Math.html#a53869f3197b0f991aea7f5edf6b620e2" title="Arc cosine function.">Math::ACos</a>(dot);
<a name="l00764"></a>00764 
<a name="l00765"></a>00765             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(angle.<a class="code" href="classOgre_1_1Radian.html#ae48b00b9345103217741b497108848d2">valueRadians</a>()) &lt;= tolerance.<a class="code" href="classOgre_1_1Radian.html#ae48b00b9345103217741b497108848d2">valueRadians</a>();
<a name="l00766"></a>00766 
<a name="l00767"></a>00767         }
<a name="l00768"></a>00768 
<a name="l00770"></a><a class="code" href="classOgre_1_1Vector3.html#a08d96f2049dba67c95790f6b7b0fcb5c">00770</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isNaN()<span class="keyword"> const</span>
<a name="l00771"></a>00771 <span class="keyword">        </span>{
<a name="l00772"></a>00772             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(x) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(y) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(z);
<a name="l00773"></a>00773         }
<a name="l00774"></a>00774 
<a name="l00776"></a><a class="code" href="classOgre_1_1Vector3.html#a3dd99d8107491125e51b66cc01a94722">00776</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> primaryAxis()<span class="keyword"> const</span>
<a name="l00777"></a>00777 <span class="keyword">        </span>{
<a name="l00778"></a>00778             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> absx = <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(x);
<a name="l00779"></a>00779             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> absy = <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(y);
<a name="l00780"></a>00780             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> absz = <a class="code" href="classOgre_1_1Math.html#ae9e2434f05aed3c19b600af6b48c59b7" title="Absolute value function.">Math::Abs</a>(z);
<a name="l00781"></a>00781             <span class="keywordflow">if</span> (absx &gt; absy)
<a name="l00782"></a>00782                 <span class="keywordflow">if</span> (absx &gt; absz)
<a name="l00783"></a>00783                     <span class="keywordflow">return</span> x &gt; 0 ? <a class="code" href="classOgre_1_1Vector3.html#a0c21d1f120c5eab83aa966e5de1df311">Vector3::UNIT_X</a> : <a class="code" href="classOgre_1_1Vector3.html#a46e43c65e6da1ff630652694a966d63c">Vector3::NEGATIVE_UNIT_X</a>;
<a name="l00784"></a>00784                 <span class="keywordflow">else</span>
<a name="l00785"></a>00785                     <span class="keywordflow">return</span> z &gt; 0 ? <a class="code" href="classOgre_1_1Vector3.html#ad25aed2e9367cfa879d3e3c231c5a136">Vector3::UNIT_Z</a> : <a class="code" href="classOgre_1_1Vector3.html#abdeebea4e94e114215a51831f9792f19">Vector3::NEGATIVE_UNIT_Z</a>;
<a name="l00786"></a>00786             <span class="keywordflow">else</span> <span class="comment">// absx &lt;= absy</span>
<a name="l00787"></a>00787                 <span class="keywordflow">if</span> (absy &gt; absz)
<a name="l00788"></a>00788                     <span class="keywordflow">return</span> y &gt; 0 ? <a class="code" href="classOgre_1_1Vector3.html#a8d1a1f7af535bcc8d9c78b1732bc1b90">Vector3::UNIT_Y</a> : <a class="code" href="classOgre_1_1Vector3.html#a6b674c303fc2ade68ce2fd6ae74b8c11">Vector3::NEGATIVE_UNIT_Y</a>;
<a name="l00789"></a>00789                 <span class="keywordflow">else</span>
<a name="l00790"></a>00790                     <span class="keywordflow">return</span> z &gt; 0 ? <a class="code" href="classOgre_1_1Vector3.html#ad25aed2e9367cfa879d3e3c231c5a136">Vector3::UNIT_Z</a> : <a class="code" href="classOgre_1_1Vector3.html#abdeebea4e94e114215a51831f9792f19">Vector3::NEGATIVE_UNIT_Z</a>;
<a name="l00791"></a>00791 
<a name="l00792"></a>00792 
<a name="l00793"></a>00793         }
<a name="l00794"></a>00794 
<a name="l00795"></a>00795         <span class="comment">// special points</span>
<a name="l00796"></a><a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">00796</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">ZERO</a>;
<a name="l00797"></a><a class="code" href="classOgre_1_1Vector3.html#a0c21d1f120c5eab83aa966e5de1df311">00797</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Vector3.html#a0c21d1f120c5eab83aa966e5de1df311">UNIT_X</a>;
<a name="l00798"></a><a class="code" href="classOgre_1_1Vector3.html#a8d1a1f7af535bcc8d9c78b1732bc1b90">00798</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Vector3.html#a8d1a1f7af535bcc8d9c78b1732bc1b90">UNIT_Y</a>;
<a name="l00799"></a><a class="code" href="classOgre_1_1Vector3.html#ad25aed2e9367cfa879d3e3c231c5a136">00799</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Vector3.html#ad25aed2e9367cfa879d3e3c231c5a136">UNIT_Z</a>;
<a name="l00800"></a><a class="code" href="classOgre_1_1Vector3.html#a46e43c65e6da1ff630652694a966d63c">00800</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Vector3.html#a46e43c65e6da1ff630652694a966d63c">NEGATIVE_UNIT_X</a>;
<a name="l00801"></a><a class="code" href="classOgre_1_1Vector3.html#a6b674c303fc2ade68ce2fd6ae74b8c11">00801</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Vector3.html#a6b674c303fc2ade68ce2fd6ae74b8c11">NEGATIVE_UNIT_Y</a>;
<a name="l00802"></a><a class="code" href="classOgre_1_1Vector3.html#abdeebea4e94e114215a51831f9792f19">00802</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Vector3.html#abdeebea4e94e114215a51831f9792f19">NEGATIVE_UNIT_Z</a>;
<a name="l00803"></a><a class="code" href="classOgre_1_1Vector3.html#a6a27e8a3a9156701f586afeed1516fb8">00803</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Vector3.html#a6a27e8a3a9156701f586afeed1516fb8">UNIT_SCALE</a>;
<a name="l00804"></a>00804 
<a name="l00807"></a>00807         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00808"></a><a class="code" href="classOgre_1_1Vector3.html#a64adb4b87769f63f900fef109e4c4f3b">00808</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v )
<a name="l00809"></a>00809         {
<a name="l00810"></a>00810             o &lt;&lt; <span class="stringliteral">&quot;Vector3(&quot;</span> &lt;&lt; v.x &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; v.y &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; v.z &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>;
<a name="l00811"></a>00811             <span class="keywordflow">return</span> o;
<a name="l00812"></a>00812         }
<a name="l00813"></a>00813     };
<a name="l00817"></a>00817 }
<a name="l00818"></a>00818 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
